<?php
function getTimeFromNTP($host = 'pool.ntp.org', $timeout = 10)
{
    $socket = stream_socket_client('udp://' . $host . ':123', $errno, $errstr, (int)$timeout);
    $msg = "\010" . str_repeat("\0", 47);
    fwrite($socket, $msg);
    $response = fread($socket, 48);
    fclose($socket);
    // unpack to unsigned long
    $data = unpack('N12', $response);
    // 9 =  Receive Timestamp (rec): Time at the server when the request arrived
    // from the client, in NTP timestamp format.
    $timestamp = sprintf('%u', $data[9]);
    // NTP = number of seconds since January 1st, 1900
    // Unix time = seconds since January 1st, 1970
    // remove 70 years in seconds to get unix timestamp from NTP time
    $timestamp -= 2208988800;
    return $timestamp;
}

function downcounter($date){
    $check_time = strtotime($date) - time();
    if($check_time <= 0){
        return false;
    }

    $days = floor($check_time/86400);
    $hours = floor(($check_time%86400)/3600);
    $minutes = floor(($check_time%3600)/60);
    $seconds = $check_time%60;

    $str = '';
    if($days > 0) $str .= declension($days,array('день','дня','дней')).' ';
    if($hours > 0) $str .= declension($hours,array('час','часа','часов')).' ';
    if($minutes > 0) $str .= declension($minutes,array('минута','минуты','минут')).' ';
//    if($seconds > 0) $str .= declension($seconds,array('секунда','секунды','секунд'));

    return $str;
}



function declension($digit,$expr,$onlyword=false){
    if(!is_array($expr)) $expr = array_filter(explode(' ', $expr));
    if(empty($expr[2])) $expr[2]=$expr[1];
    $i=preg_replace('/[^0-9]+/s','',$digit)%100;
    if($onlyword) $digit='';
    if($i>=5 && $i<=20) $res=$digit.' '.$expr[2];
    else
    {
        $i%=10;
        if($i==1) $res=$digit.' '.$expr[0];
        elseif($i>=2 && $i<=4) $res=$digit.' '.$expr[1];
        else $res=$digit.' '.$expr[2];
    }
    return trim($res);
}